/*
 *  Copyright (C) 2025 Texas Instruments Incorporated
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions
 *  are met:
 *
 *    Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *
 *    Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the
 *    distribution.
 *
 *    Neither the name of Texas Instruments Incorporated nor the names of
 *    its contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 *  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 *  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 *  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 *  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 *  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 *  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 *  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 *  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 *  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 *  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 *  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 */
/**
 * \ingroup TISCI
 * \defgroup tisci_csp tisci_csp
 *
 * DMSC controls the power management, security and resource management
 * of the device.
 *
 *
 * @{
 */
/**
 *
 *  \brief  This file contains:
 *
 *          WARNING!!: Autogenerated file from SYSFW. DO NOT MODIFY!!
 * System Firmware
 *
 * TISCI Data structures and macros for runtime keystore
 *
 */
#ifndef TISCI_CSP_H_
#define TISCI_CSP_H_


#define TISCI_CSP_AES_TAGLEN 16u

/**
 * \brief Request for encryption/decryption
 *
 * \param ctx_address_lo Lower 32-bit memory location of the context
 * \param ctx_address_hi Higher 32-bit memory location of the context
 */
struct csp_aes_opn_req_data {
    uint32_t ctx_address_lo;
    uint32_t ctx_address_hi;
} __attribute__((__packed__));

/**
 * \brief Response of the encryption/decryption process
 *
 * \param tag The tag obtained during encyption/decryption
 */
struct csp_aes_opn_resp_data {
    uint8_t tag[TISCI_CSP_AES_TAGLEN];
} __attribute__((__packed__));

/**
 * \brief Request for encryption/decryption
 *
 * \param hdr tisci header
 * \param aes_req Structure containing context address
 */
struct tisci_csp_aes_req {
    struct tisci_header hdr;
    struct csp_aes_opn_req_data aes_req;
} __attribute__((__packed__));

/**
 * \brief Response of the encryption/decryption process
 *
 * \param hdr tisci header
 * \param aes_resp Structure containing service response
 */
struct tisci_csp_aes_resp {
    struct tisci_header hdr;
    struct csp_aes_opn_resp_data aes_resp;
} __attribute__((__packed__));

#endif

/* @} */
